\ all sources uses hex base
hex

\ return a number, right padded with 0 until "len" characters
: hex-padded ( number len -- addr u )
    0 swap 0 <# do # loop #>
;

\ common virtual machine definition for the target system
needs vm.f

\ "vm-code" and "end-cod" for assembling to the target system
needs assembler.f

\ "vm-steps" and "vm-step" for emulating the CPU
needs emulator.f

\ for writing memory initialization files
needs export.f

\ define a test program
vm-code

.org    100

\ start of main program
: start cmd-literal 1 call led  \ LED on
        cmd-literal 0 call led  \ LED off

        \ test keyboard
        cmd-literal-a keyboard-port cmd-a@
        cmd-literal-a 1 cmd-and cmd-literal-a end cmd-branch-a
        cmd-jump-literal start

        \ stop CPU, if key at bit 0 was pressed
: end   cmd-jump-literal end

\ switch LED on/off
: led   \ xor with keyboard buffer
        cmd-literal-a keyboard-port cmd-a@ cmd->a cmd-xor

        \ store at led-port
        cmd-literal-a led-port cmd-a!

        \ wait half a second
        call 05s
        cmd-return

\ push TOS to data stack
: vm-dup
        cmd->a cmd-a> cmd-a>
        cmd-return

\ delay half a second (500=0x1f4 milliseconds)
: 05s   cmd-literal 1f4
: l1    call 1ms
        call decr
        call vm-dup cmd-literal-a l1 cmd-branch-a
        cmd->a cmd-return

\ delay about one millisecond
: 1ms   cmd-literal 2f0
: l2    call decr
        call vm-dup cmd-literal-a l2 cmd-branch-a
        cmd->a cmd-return

\ substract 1 from TOS
: decr  cmd-literal-a ffff cmd-plus
        cmd-return

end-code

\ write memory initialization files
write-mif
write-coe

\ emulate 0x100 cycles of the virtual machine
100 vm-steps
